"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .project import Project, ProjectTypedDict
from datetime import datetime
from duckyai.types import BaseModel
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class OrganizationTypedDict(TypedDict):
    org_id: NotRequired[str]
    r"""The unique identifier of the organization from Clerk."""
    org_name: NotRequired[str]
    r"""The name of the organization."""
    owner_id: NotRequired[str]
    r"""The user ID of the organization's owner."""
    created_at: NotRequired[datetime]
    r"""The timestamp when the organization was created."""
    updated_at: NotRequired[datetime]
    r"""The timestamp when the organization was last updated."""
    projects: NotRequired[List[ProjectTypedDict]]


class Organization(BaseModel):
    org_id: Optional[str] = None
    r"""The unique identifier of the organization from Clerk."""

    org_name: Optional[str] = None
    r"""The name of the organization."""

    owner_id: Optional[str] = None
    r"""The user ID of the organization's owner."""

    created_at: Optional[datetime] = None
    r"""The timestamp when the organization was created."""

    updated_at: Optional[datetime] = None
    r"""The timestamp when the organization was last updated."""

    projects: Optional[List[Project]] = None
